#include "Core_Mesh/Mesh.h"
#include "Core_Mesh/Iterators.h"
#include <iostream>

using namespace XMeshLib;

void help()
{
	std::cout << "Two parameters: an input mesh (e.g.torus.m) and an output mesh (e.g. result.m)" << std::endl;
	exit(0);
}
int main(int argc, char ** argv)
{
	if (argc!=3) //need two parameters
		help();

	Mesh * mesh1 = new Mesh;
	bool rSucc = mesh1->read(argv[1]);
	if (!rSucc)	return 0;
	Mesh cmesh;
	mesh1->copyTo(cmesh);
	//delete mesh1;
	bool wSucc = cmesh.write(argv[2]);
	if (!wSucc)	return 0;

	std::cout << "The following shows the usage of iterators... "<< std::endl;
	int testVerNum=0;
	for (MeshVertexIterator viter(&cmesh); !viter.end(); ++viter)
	{
		Vertex * v = *viter;
		testVerNum++;
	}
	std::cout << "total vertex # = " << testVerNum << std::endl;

	int testVerNum2=0;
	for (MeshFaceIterator fiter(&cmesh); !fiter.end(); ++fiter)
	{
		Face * f = * fiter;
		for (FaceVertexIterator fvit(f); !fvit.end(); ++fvit)
		{
			Vertex * v= *fvit;
			testVerNum2++;
		}
	}
	std::cout << "total corner # = " << testVerNum2 << " (Why?) " << std::endl;

	int testFaceNum=0;
	for (MeshFaceIterator fit(&cmesh); !fit.end(); ++fit)
	{
		testFaceNum++;
	}
	std::cout << "total face # = " << testFaceNum << std::endl;


	int testFNum=0;
	for (MeshVertexIterator vit(&cmesh); !vit.end(); ++vit)
	{
		Vertex * v = *vit;
		for (VertexFaceIterator vfit(v); !vfit.end(); ++vfit)
		{
			testFNum++;
		}
	}
	std::cout << "total face # (computed by another method): " << testFNum << " (What happened?) " << std::endl;

	return 1;
}